#pragma sfr
#pragma DI
#pragma EI

#include "trgbios.h" // gZBIOS̃T[rX[`ĂяôɕKv

#define NULL ((void *)0)

const unsigned char gamma[] = {
  0,  0,  1,  2,  4,  6,  9, 12 ,15, 19, 24, 29, 35, 41, 48, 55,
  63, 72,81,91, 101,112,123,135,148,162,176,190,206,222,238,255
};

unsigned short ledCount;
unsigned char  ledPWM;
unsigned char  ledSpeedUp;

void intsrv_tim(void)
{
	unsigned short sig;

	// PWM\tgEFAŎ
	if((ledCount & 0xff) < ledPWM)
	{
		P6.1 = 0; // _
	}
	else
	{
		P6.1 = 1; // 
	}
	ledCount++;
	if(ledSpeedUp) ledCount++; // Xs[hAbv

	sig = (ledCount >> 8) & 0x3f;

	if(sig > 31)
	{
		sig = 63 - sig;
	}
	ledPWM = gamma[sig & 0x1f];

	// ^C}[荞݃tONA
	IF0H.6 = 0;
}

void main() // C
{
	unsigned short i;
	unsigned char standAlone = 0;
	unsigned char ramMode = 0;
	unsigned char biosExists = 0;
	unsigned char first = 1;

	PM6  = 0xfd;		/*PM61 = 0, PM60 = 1*/
	ledSpeedUp = 0;

	if((unsigned short)main >= 0xf000) // vO̊JnԒn𒲂ׂ
	{
		// RAM̈ŎĂȂBIOSNĂ
		ramMode = 1;
		biosExists = 1;
	}
	if((trg_getstatus(NULL) & 0x10) == 0) // Connected
	{
		// ɐڑĂȂBIOSNĂ
		biosExists = 1;
	}
	
	ledCount = 0;
	
	if(!biosExists)
	{
		trg_usbopen();
	}

	for(i = 0; i< 10; i++)
	{
		unsigned short j;
		P6.1 ^= 1; // _
		for(j = 0; j < 10000 ; j++) {}
	}

	trg_regintsrv(TRG_INTID_BSITM000,intsrv_tim); // 荞݃nho^

	PRM00 = 1;
	CR000 = 0x100;  // 荞ݎ
	TMC00 = 0x0C;   // JEgJn
	MK0H.6 = 0;     // TM000荞݋

	while(1)
	{
		if((trg_getstatus(NULL) & 0x10) == 0) // Connected
		{
			unsigned short j;
			unsigned char c;

			ledSpeedUp = 0;
			if(first)
			{
				for(j = 0; j < 10000 ; j++) {} // ̎ԑ҂͕K{

				trg_puts("Timer Sample Version 1.4 ");
				if(!biosExists)
				{
					trg_puts("Standalone , ");
				}

				if(ramMode)
				{
					trg_puts("RAM\n");
				}
				else
				{
					trg_puts("ROM\n");
				}
				first = 0;
			}

			if(trg_getrecvcount())
			{
				c = trg_getc();
				if(c == 'x')
				{
					trg_puts("\n");

					MK0H.6 = 1;     // TM000荞݃}XN
					for(i = 0; i< 40; i++)
					{
						P6.1 ^= 1; // _
						for(j = 0; j < 10000 ; j++) {}
						trg_puts(".");
					}
					MK0H.6 = 0;     // TM000荞݋

					if(biosExists)
					{
						break;
					}
					else
					{
						trg_puts(" x肩܂\n");
					}
				}
				else
				{
					trg_puts("xL[Ă\n");
				}
			}
		
		}
		else
		{
			ledSpeedUp = 1;
		}
	}

	P6.1 = 0;
	TMC00 = 0x00;   // JEg~
	MK0H.6 = 1;     // TM000荞݃}XN
}





/*#pragma sfr
#include "trgbios.h"

unsigned short num;
char	c;
unsigned char s[10];

void main() {
    PM6.1 = 0; // LED ̃|[go͗pɂ
    trg_puts("Hello LED `J`J\n");
    while(1) {
       // char c = trg_getc(); // USB 1 擾
        num = trg_getrecvcount();
			trg_recvdata(&s[0], num);
			if (num > 5) break;
			
        switch (num)
        {
        case 0:
        
	        break;
        case 1:
//        	c = trg_getc(); // USB 1 擾
    		trg_senddata(*s, num);
    		trg_puts("1\n");
	        break;
        case 2:
    		trg_senddata(&s[0], num);
			trg_puts("2\n");
	        break;
        case 3:
    		trg_senddata(*s, num);
    		trg_puts("3\n");
	        break;
        case 4:
    		trg_senddata(*s, num);
    		trg_puts("4\n");
	        break;
        case 5:
    		trg_senddata(*s, num);
    		trg_puts("5\n");
	        break;
		}
        
        P6.1 ^= 0x01;        // LED ̃|[g_
    }
}
*/
